#ifdef WIN32
	#pragma comment(lib, "Ws2_32.lib")
	#define WIN32_LEAN_AND_MEAN
	#include <winsock.h>

#endif

#ifdef __linux__
	#include <socket.h>
#endif

#include <Endianness.hpp>

namespace Endianness
{

	// TODO: Manually swap bytes so we can depend less on clunky include directives.
	u16 HostToNetworkOrder(u16 host)	{ return ReverseByteOrderIfLittleEndian(host); }
	u16 NetworkToHostOrder(u16 network) { return ReverseByteOrderIfLittleEndian(network); }
	s16 HostToNetworkOrder(s16 host)	{ return ReverseByteOrderIfLittleEndian( host); }
	s16 NetworkToHostOrder(s16 network) { return ReverseByteOrderIfLittleEndian(network);}
	u32 HostToNetworkOrder(u32 host)	{ return ReverseByteOrderIfLittleEndian(host); }
	u32 NetworkToHostOrder(u32 network) { return ReverseByteOrderIfLittleEndian(network); }
	s32 HostToNetworkOrder(s32 host)	{ return ReverseByteOrderIfLittleEndian(host);}
	s32 NetworkToHostOrder(s32 network) { return ReverseByteOrderIfLittleEndian(network);}
	u64 HostToNetworkOrder(u64 host)	{ return ReverseByteOrderIfLittleEndian(host);    }
	u64 NetworkToHostOrder(u64 network) { return ReverseByteOrderIfLittleEndian(network); }
	s64 HostToNetworkOrder(s64 host)	{ return ReverseByteOrderIfLittleEndian(host);    }
	s64 NetworkToHostOrder(s64 network) { return ReverseByteOrderIfLittleEndian(network); }


	float HostToNetworkOrder(float host) {
		if (IsLittleEndian())
			return ReverseByteOrder(host);
		else
			return host;
	}

	float NetworkToHostOrder(float network) {
		if (IsLittleEndian())
			return ReverseByteOrder(network);
		else
			return network;
	}

	double HostToNetworkOrder(double host) {
		if (IsLittleEndian())
			return ReverseByteOrder(host);
		else
			return host;
	}

	double NetworkToHostOrder(double network) {
		if (IsLittleEndian())
			return ReverseByteOrder(network);
		else
			return network;
	}
}